﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace DS_CommonAPISample
{
    class DS_CommonAPI
    {
        public enum DS_MODELTYPE
        {
            DS_TYPE_ERROR = -1,
            DS_3 = 1,
            DS_7 = 2,
            DS_31 = 3,
            DS_5 = 4,
        };

        public enum DS_READER_TYPE
        {
            UNKNOWN = -1,
            SCANNER = 0,
            IMAGER = 1,
            IMAGER_GEN6 = 2,
            IMAGER_SE4500 = 3,
            SCANNER_N4313 = 4,
            IMAGER_SE4750 = 5,
            MAX_READER = 6,
        };
      
        //[WM] only
        public enum  DS_KEY_MODE
        {
	        VKEY_MODE = 1,					//DS3 & DS3.1 & DS5 34Key & DS5 54Key
	        FKEY_MODE = 2,					//DS5 34Key & DS5 54Key
	        AKEY_MODE = 3,					//DS5 54Key only
        };

        [DllImport("DS_CommonAPI.dll")]
        public static extern Boolean DSAPISetVibrator(int nTime);

        [DllImport("DS_CommonAPI.dll")]
        public static extern Boolean DSAPISetRFPower(Boolean bPwrOn);

        [DllImport("DS_CommonAPI.dll")]
        public static extern Boolean DSAPIGetRFPower(ref Boolean pbPwrState);

        [DllImport("DS_CommonAPI.dll")]
        public static extern Boolean DSAPISetCameraFlashOnOff(Boolean bOn);

        [DllImport("DS_CommonAPI.dll")]
        public static extern Boolean DSAPISetWLANPower(Boolean bPwrOn);

        [DllImport("DS_CommonAPI.dll")]
        public static extern Boolean DSAPIGetWLANPower(ref Boolean pbPwrState);

        //DS5 Only
        [DllImport("DS_CommonAPI.dll")]
        public static extern Boolean DSAPISetFrontLEDOnOff(Boolean bOn);

        [DllImport("DS_CommonAPI.dll")]
        public static extern DS_MODELTYPE DSAPIGetModel();

        [DllImport("DS_CommonAPI.dll")]
        public static extern DS_READER_TYPE DSAPIGetBarcodeType();

        [DllImport("DS_CommonAPI.dll")]
        public static extern Boolean DSAPIKeyMapping_RegisterKey(int nVKey, int nVKeyNew);

        [DllImport("DS_CommonAPI.dll")]
        public static extern Boolean DSAPIKeyMapping_UnregisterKey(int nVKey);

        [DllImport("DS_CommonAPI.dll")]
        public static extern Boolean DSAPIKeyMapping_RegisterKeyA(DS_KEY_MODE enKeyMode, int nIndex, byte btKeyCode);

        [DllImport("DS_CommonAPI.dll")]
        public static extern Boolean DSAPIKeyMapping_UnregisterKeyA(DS_KEY_MODE enKeyMode, int nIndex);

        //20141125 jinni. [WM] only
        //SCAN Key Register or Unregister function (with DS_BarcodeTray)
        [DllImport("DS_CommonAPI.dll")]
        public static extern Boolean DSAPIBarcodeTraySCANKeyEnable(int nVKey, Boolean bEnable);
        //20150326 jinni. 
        [DllImport("DS_CommonAPI.dll")]
        public static extern Boolean DSAPIKeyMapping_Flush(DS_KEY_MODE enKeyMode);
        //20150415 jinni. 
        [DllImport("DS_CommonAPI.dll")]
        public static extern Boolean DSAPIKeyMapping_Query(DS_KEY_MODE enKeyMode);
        //20150407 jinni. 
        [DllImport("DS_CommonAPI.dll")]
        public static extern void DSAPIReboot();
    }
}
