﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.WindowsCE.Forms;
using System.Runtime.InteropServices;

namespace DS_CommonAPISample
{


    public partial class MainForm : Form
    {

        //PDA Side Key Value
        public const int VK_LEFTSCAN = 0xEE;
        public const int VK_RIGHTSCAN = 0xEF;
        public const int VK_MIDDLESCAN = 0xED;
        public const int VK_GUNTRIGGER = 0xF1;

        //MSGWindow msgWin;

        public class SYSTEM_POWER_STATUS_EX2
        {
            public byte ACLineStatus;
            public byte BatteryFlag;
            public byte BatteryLifePercent;
            public byte Reserved1;
            public uint BatteryLifeTime;
            public uint BatteryFullLifeTime;
            public byte Reserved2;
            public byte BackupBatteryFlag;
            public byte BackupBatteryLifePercent;
            public byte Reserved3;
            public uint BackupBatteryLifeTime;
            public uint BackupBatteryFullLifeTime;
            public uint BatteryVoltage;
            public uint BatteryCurrent;
            public uint BatteryAverageCurrent;
            public uint BatteryAverageInterval;
            public uint BatterymAHourConsumed;
            public uint BatteryTemperature;
            public uint BackupBatteryVoltage;
            public byte BatteryChemistry;
        }

        public class SYSTEM_POWER_STATUS_EX
        {
            public byte ACLineStatus;
            public byte BatteryFlag;
            public byte BatteryLifePercent;
            public byte Reserved1;
            public uint BatteryLifeTime;
            public uint BatteryFullLifeTime;
            public byte Reserved2;
            public byte BackupBatteryFlag;
            public byte BackupBatteryLifePercent;
            public byte Reserved3;
            public uint BackupBatteryLifeTime;
            public uint BackupBatteryFullLifeTime;
        }

        [DllImport("coredll.dll")]
        public static extern bool GetSystemPowerStatusEx(SYSTEM_POWER_STATUS_EX lpSystemPowerStatus, bool fUpdate);

        [DllImport("coredll.dll")]
        public static extern int GetSystemPowerStatusEx2(SYSTEM_POWER_STATUS_EX2 lpSystemPowerStatus, uint dwLen, bool fUpdate);


        public MainForm()
        {
            InitializeComponent();
        }

        private void FlashOn_Click(object sender, EventArgs e)
        {
            DS_CommonAPI.DSAPISetCameraFlashOnOff(true);
        }

        private void FlashOff_Click(object sender, EventArgs e)
        {
            DS_CommonAPI.DSAPISetCameraFlashOnOff(false);
        }

        private void Close_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            DS_CommonAPI.DSAPISetWLANPower(true);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            DS_CommonAPI.DSAPISetWLANPower(false);
        }

         private void button4_Click(object sender, EventArgs e)
        {
            DS_CommonAPI.DSAPISetFrontLEDOnOff(true);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            DS_CommonAPI.DSAPISetFrontLEDOnOff(false);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            DS_CommonAPI.DS_MODELTYPE dsType;
            dsType = DS_CommonAPI.DSAPIGetModel();

            switch (dsType)
            {
                case DS_CommonAPI.DS_MODELTYPE.DS_3:
                    MessageBox.Show("DS3");
                    break;
                case DS_CommonAPI.DS_MODELTYPE.DS_7:
                    MessageBox.Show("DS7");
                    break;
                case DS_CommonAPI.DS_MODELTYPE.DS_31:
                    MessageBox.Show("DS31");
                    break;
                case DS_CommonAPI.DS_MODELTYPE.DS_5:
                    MessageBox.Show("DS5");
                    break;
                case DS_CommonAPI.DS_MODELTYPE.DS_TYPE_ERROR:
                    MessageBox.Show("Error");
                    break;

            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            DS_CommonAPI.DS_READER_TYPE dsReader;
            dsReader = DS_CommonAPI.DSAPIGetBarcodeType();
            switch (dsReader)
            {
                case DS_CommonAPI.DS_READER_TYPE.SCANNER:
                    MessageBox.Show("1D");
                    break;
                case DS_CommonAPI.DS_READER_TYPE.IMAGER:
                    MessageBox.Show("2D");
                    break;
                case DS_CommonAPI.DS_READER_TYPE.IMAGER_GEN6:
                    MessageBox.Show("2D_Gen6");
                    break;
                case DS_CommonAPI.DS_READER_TYPE.IMAGER_SE4500:
                    MessageBox.Show("2D_SE4500");
                    break;
                case DS_CommonAPI.DS_READER_TYPE.SCANNER_N4313:
                    MessageBox.Show("1D_N4313");
                    break;
                case DS_CommonAPI.DS_READER_TYPE.IMAGER_SE4750:
                    MessageBox.Show("2D_SE4750");
                    break;
                case DS_CommonAPI.DS_READER_TYPE.UNKNOWN:
                    MessageBox.Show("UNKNOWN");
                    break;

            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            DS_CommonAPI.DSAPIBarcodeTraySCANKeyEnable(VK_LEFTSCAN, false);
            DS_CommonAPI.DSAPIBarcodeTraySCANKeyEnable(VK_RIGHTSCAN, false);
            DS_CommonAPI.DSAPIBarcodeTraySCANKeyEnable(VK_MIDDLESCAN, false);
            DS_CommonAPI.DSAPIBarcodeTraySCANKeyEnable(VK_GUNTRIGGER, false);

            // WM_HOTKEY Enable. (RegisterHotKey)
            //msgWin = new MSGWindow(this); 

        }

        private void button8_Click(object sender, EventArgs e)
        {
            // WM_HOTKEY Disable. (UnregisterHotKey)
            //msgWin.Dispose();
            label1.Text = "";


            DS_CommonAPI.DSAPIBarcodeTraySCANKeyEnable(VK_LEFTSCAN, true);
            DS_CommonAPI.DSAPIBarcodeTraySCANKeyEnable(VK_RIGHTSCAN, true);
            DS_CommonAPI.DSAPIBarcodeTraySCANKeyEnable(VK_MIDDLESCAN, true);
            DS_CommonAPI.DSAPIBarcodeTraySCANKeyEnable(VK_GUNTRIGGER, true);
        }
        //label1.Text = "Key Code : " + e.KeyChar.ToString();

        public void LabelPrint(string str)
        {
            label1.Text = str;
        }

        private void button9_Click(object sender, EventArgs e)
        {

            //Battery Check 

            String BatteryLife  ="0%";
            String BatteryLife2 = "0%";
            SYSTEM_POWER_STATUS_EX status = new SYSTEM_POWER_STATUS_EX();
            SYSTEM_POWER_STATUS_EX2 status2 = new SYSTEM_POWER_STATUS_EX2();

            

            if (GetSystemPowerStatusEx(status, false))
            {
                BatteryLife = String.Format("{0}%, ACLine : {1}", status.BatteryLifePercent, status.ACLineStatus);
            }
            MessageBox.Show(BatteryLife);

            //if (GetSystemPowerStatusEx2(status2, (uint)Marshal.SizeOf(status2), false) == (uint)Marshal.SizeOf(status2))
            //{
            //    BatteryLife2 = String.Format("{0}%, ACLine : {1}", status2.BatteryLifePercent, status.ACLineStatus);
            //}

            //MessageBox.Show(BatteryLife2);
        }

        private void button10_Click(object sender, EventArgs e)
        {
            if (DS_CommonAPI.DSAPIKeyMapping_Query(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE))
            {
                //Left, Right, Up, Down key Enable
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 56, 0x00);
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 58, 0x00);
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 59, 0x00);
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 65, 0x00);
                DS_CommonAPI.DSAPIKeyMapping_Flush(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE);
            }
        }

        private void button11_Click(object sender, EventArgs e)
        {
            if (DS_CommonAPI.DSAPIKeyMapping_Query(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE))
            {
               //Left, Right, Up, Down key Enable
                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 56);
                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 58);
                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 59);
                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 65);
                DS_CommonAPI.DSAPIKeyMapping_Flush(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE);
            }
        }

        private void MainForm_KeyDown(object sender, KeyEventArgs e)
        {
            LabelPrint(string.Format("Key Down : {0}", e.KeyCode));
        }

        private void button12_Click(object sender, EventArgs e)
        {
            if (DS_CommonAPI.DSAPIKeyMapping_Query(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE))
            {
                //F3, F4 system key Enable
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 68, 0x72);
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 69, 0x73);

                //F1 -> F15
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 66, 0x7E);
                //F2 -> F16                                                                   
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 67, 0x7F);

                // TAB -> Enter -> F20                                                                
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 57, 0x83);

                // 초록색버튼 -> F11
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 61, 0x7A);

                // 붉은색버튼 -> F12
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 62, 0x7B);

                // Enter -> TAB -> NULL                                                                
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 60, 0x00);

                DS_CommonAPI.DSAPIKeyMapping_Flush(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE);
            }



            if (DS_CommonAPI.DSAPIKeyMapping_Query(DS_CommonAPI.DS_KEY_MODE.FKEY_MODE))
            {
                // F6, F7 system key Enable
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.FKEY_MODE, 10, 0x75);
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.FKEY_MODE, 11, 0x76);

                // Func+UP -> F13, 124                                                                   
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.FKEY_MODE, 19, 0x7C);
                // Func+DOWN -> F14, 125                                                                 
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.FKEY_MODE, 20, 0x7D);

                //WIN -> NULL                                                                 
                DS_CommonAPI.DSAPIKeyMapping_RegisterKeyA(DS_CommonAPI.DS_KEY_MODE.FKEY_MODE, 15, 0x00);
                DS_CommonAPI.DSAPIKeyMapping_Flush(DS_CommonAPI.DS_KEY_MODE.FKEY_MODE);
            }
        }

        private void button13_Click(object sender, EventArgs e)
        {
            if (DS_CommonAPI.DSAPIKeyMapping_Query(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE))
            {
                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 68);
                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 69);

                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 66);
                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 67);

                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 57);
                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 61);

                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 62);
                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE, 60);

                DS_CommonAPI.DSAPIKeyMapping_Flush(DS_CommonAPI.DS_KEY_MODE.VKEY_MODE);
            }


            if (DS_CommonAPI.DSAPIKeyMapping_Query(DS_CommonAPI.DS_KEY_MODE.FKEY_MODE))
            {
                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.FKEY_MODE, 10);
                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.FKEY_MODE, 11);

                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.FKEY_MODE, 19);
                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.FKEY_MODE, 20);

                DS_CommonAPI.DSAPIKeyMapping_UnregisterKeyA(DS_CommonAPI.DS_KEY_MODE.FKEY_MODE, 15);

                DS_CommonAPI.DSAPIKeyMapping_Flush(DS_CommonAPI.DS_KEY_MODE.FKEY_MODE);
            }
        }

        private void button16_Click(object sender, EventArgs e)
        {
            DS_CommonAPI.DSAPIReboot();
        }

        private void button17_Click(object sender, EventArgs e)
        {
            DS_CommonAPI.DSAPISetVibrator(500);
        }




    }

    public class MSGWindow : MessageWindow
    {
        //HotKey Setting
        [DllImport("coredll.dll")]
        public static extern bool RegisterHotKey(System.IntPtr hWnd, int id, int fsModifiers, int vk);
        [DllImport("coredll.dll")]
        public static extern bool UnregisterHotKey(System.IntPtr hWnd, int id);

        public const int WM_CUSTOMMSG = 0x0400;

        //Hotkey Message
        public const int WM_HOTKEY = 0x0312;
        public const int MOD_KEYUP = 0x1000;

        //PDA Side Key Value
        public const int VK_LEFTSCAN   = 0xEE;
        public const int VK_RIGHTSCAN  = 0xEF;
        public const int VK_MIDDLESCAN = 0xED;
        public const int VK_GUNTRIGGER = 0xF1;

        bool m_bScanning = false;

        private MainForm SampleForm;

        public MSGWindow(MainForm msgForm)
        {
            this.SampleForm = msgForm;

            RegisterHotKey(this.Hwnd, VK_LEFTSCAN, MOD_KEYUP, VK_LEFTSCAN);
            RegisterHotKey(this.Hwnd, VK_RIGHTSCAN, MOD_KEYUP, VK_RIGHTSCAN);
            RegisterHotKey(this.Hwnd, VK_MIDDLESCAN, MOD_KEYUP, VK_MIDDLESCAN);
            RegisterHotKey(this.Hwnd, VK_GUNTRIGGER, MOD_KEYUP, VK_GUNTRIGGER);
        }

        ~MSGWindow()
        {
            UnregisterHotKey(this.Hwnd, VK_LEFTSCAN);
            UnregisterHotKey(this.Hwnd, VK_RIGHTSCAN);
            UnregisterHotKey(this.Hwnd, VK_MIDDLESCAN);
            UnregisterHotKey(this.Hwnd, VK_GUNTRIGGER);
        }

        protected override void WndProc(ref Message msg)
        {
            switch (msg.Msg)
            {
                case WM_HOTKEY:
                    int key = (int)msg.WParam;
                    //side key press
                    if (((ushort)((int)msg.LParam)) == 0x0000)
                    {
                        this.SampleForm.LabelPrint(string.Format("SCAN Key Down : {0}", key));
                    }
                    else if (((ushort)((int)msg.LParam)) == 0x1000)
                    {
                        this.SampleForm.LabelPrint(string.Format("SCAN Key Up : {0}", key));
                    }
                    break;

            }
        }
    }
}