#if !defined(__DS_WLanAPI_HEADER__)
#define __DS_WLanAPI_HEADER__


#define DSAPI_EXC	extern "C"
#define DSAPI		__declspec(dllexport)


typedef enum _eWLAN_RESULT_TYPE
{
	SUCCESS=0,
	FAIL,
	INVALID_NAME,
	INVALID_CONFIG,
	INVALID_DELETE,
	POWERCYCLE_REQUIRED,
	INVALID_PARAMETER,
	INVALID_EAP_TYPE,
	INVALID_WEP_TYPE,
	INVALID_FILE,
	INVALID_WLAN = 80,
	POWEROFF_WLAN,
}DS_WLAN_RESULT_TYPE;


typedef struct _stWLAN_STATUS
{
	DWORD	channel;
	int		rssi;
	double	bitRate;
	int     txPower;
	DWORD   DTIM;
	DWORD   beaconPeriod;
	DWORD   beaconsReceived;  
	TCHAR	SSID[33];
	TCHAR	CardState[32];
	byte    client_MAC[6];
	byte    client_IP[4];
	byte    AP_MAC[6];
	byte    AP_IP[4];
}DS_WLAN_STATUS, *PDS_WLAN_STATUS;

typedef struct _stWLAN_INFO
{
	TCHAR	SSID[33];
	int		nEncrypt;			//0: WEP_OFF, 1: WEP_ON, 2: WPA_PSK, 3: WPA2_PSK, 4: WPA_TKIP
	TCHAR	EncryptKey[33];
	DWORD	dwDHCPenable;		//0: Static, 1: DHCP
	TCHAR   IPV4Address[16];
	TCHAR   IPV4SubnetMask[16];
	TCHAR   IPV4Gateway[16];
	TCHAR   IPV4DNS1[16];
	TCHAR   IPV4DNS2[16];
	TCHAR   IPV4WINS1[16];
	TCHAR   IPV4WINS2[16];
}DS_WLAN_INFO, *PDS_WLAN_INFO;

typedef struct _stWLAN_CONFIG_NAME
{
	TCHAR ConfigName[33];
}DS_WLAN_CONFIG_NAME;

typedef struct _stWLAN_CONFIG_NAME_LIST
{
	int NumberOfItems; 
	DS_WLAN_CONFIG_NAME ConfigNameList[20];
}DS_WLAN_CONFIG_NAME_LIST;

//20131008 jinni.
DSAPI_EXC DSAPI BOOL DSAPIWLAN_GetPower	(BOOL *pbPwrState);
DSAPI_EXC DSAPI BOOL DSAPIWLAN_SetPower	(BOOL bPwrOn);		

DSAPI_EXC DSAPI BOOL DSAPIWLAN_Init();
DSAPI_EXC DSAPI BOOL DSAPIWLAN_Close();
DSAPI_EXC DSAPI int  DSAPIWLAN_AddConfig(TCHAR* szConfigName, DS_WLAN_INFO *pWlanInfo);
DSAPI_EXC DSAPI int  DSAPIWLAN_DeleteConfig(TCHAR *szConfigName);
DSAPI_EXC DSAPI int  DSAPIWLAN_ActiveConfig(TCHAR* szConfigName);
DSAPI_EXC DSAPI int  DSAPIWLAN_GetCurrentAPInfo(DS_WLAN_STATUS* pstStatus);
DSAPI_EXC DSAPI int  DSAPIWLAN_GetCurrentConfig(DWORD *dwNum, TCHAR *pszConfigName);
DSAPI_EXC DSAPI int  DSAPIWLAN_GetAllConfigName(DWORD *dwNum, DS_WLAN_CONFIG_NAME_LIST *pstConfigList);

DSAPI_EXC DSAPI int  DSAPIWLAN_ImportConfig();	//"\\Nand\\summit.sdc"
DSAPI_EXC DSAPI int  DSAPIWLAN_ExportConfig();	//"\\Nand\\summit.sdc"

DSAPI_EXC DSAPI void DSAPIWLAN_GetLastError(DS_WLAN_RESULT_TYPE* pWlanResultType);
DSAPI_EXC DSAPI int  DSAPIWLAN_ConnectAP(TCHAR* szBssid, TCHAR* szPassword, int iEncryptionType);

//20150326 jinni.
DSAPI_EXC DSAPI int  DSAPIWLAN_RadioEnable();
DSAPI_EXC DSAPI int  DSAPIWLAN_RadioDisable();
DSAPI_EXC DSAPI int  DSAPIWLAN_RadioReconnect();

#endif // !defined(__DS_WLanAPI_HEADER__)