﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace DS_WLanAPINS
{
    class DS_WLanAPI
    {
      
        public enum DS_WLAN_RESULT_TYPE
        {
	        SUCCESS=0,
	        FAIL=1,
	        INVALID_NAME=2,
	        INVALID_CONFIG=3,
	        INVALID_DELETE=4,
	        POWERCYCLE_REQUIRED=5,
	        INVALID_PARAMETER=6,
	        INVALID_EAP_TYPE=7,
	        INVALID_WEP_TYPE=8,
	        INVALID_FILE=9,
	        INVALID_WLAN = 80,
	        POWEROFF_WLAN=81,
        };

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
        public struct DS_WLAN_STATUS
        {
            public int Channel;
            public int Rssi;
            public double BitRate;
            public int txPower;
            public int DTIM;
            public int BeaconPeriod;
            public int BeaconReceived;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 33)]
            public char[] SSID;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 32)]
            public char[] CardState;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public byte[] Client_Mac;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
            public byte[] Client_IP;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public byte[] AP_Mac;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
            public byte[] AP_IP;
        };
        
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
        public struct DS_WLAN_INFO
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 33)]
	        public string	SSID;
	        public int		nEncrypt;			//0: WEP_OFF, 1: WEP_ON, 2: WPA_PSK, 3: WPA2_PSK, 4: WPA_TKIP
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 33)]
	        public string	EncryptKey;
            public int      dwDHCPenable;		//1: DHCP, 0: Static
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 16)]
            public string   IPV4Address;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 16)]
            public string   IPV4SubnetMask;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 16)]
            public string   IPV4Gateway;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 16)]
            public string   IPV4DNS1;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 16)]
            public string   IPV4DNS2;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 16)]
            public string   IPV4WINS1;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 16)]
            public string   IPV4WINS2;
        };

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
        public struct DS_WLAN_CONFIG_NAME
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 33)]
	        public string ConfigName;
        };

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
        public struct DS_WLAN_CONFIG_NAME_LIST
        {
            public int NumberOfItems;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 20)]
            public DS_WLAN_CONFIG_NAME[] ConfigList;
        };


        [DllImport("DS_WLanAPI.dll")]
        public static extern Boolean DSAPIWLAN_SetPower(Boolean bPwrOn);

        [DllImport("DS_WLanAPI.dll")]
        public static extern Boolean DSAPIWLAN_GetPower(ref Boolean pbPwrState);


        //20150215 jinni. [WLAN/SUMMIT]
        [DllImport("DS_WLanAPI.dll")]
        public static extern Boolean DSAPIWLAN_Init();
        [DllImport("DS_WLanAPI.dll")]
        public static extern Boolean DSAPIWLAN_Close();
        [DllImport("DS_WLanAPI.dll")]
        public static extern void DSAPIWLAN_GetLastError(ref DS_WLAN_RESULT_TYPE pWlanResultType);
        [DllImport("DS_WLanAPI.dll")]
        public static extern int DSAPIWLAN_ConnectAP(string szBssid, string szPassword, int iEncryptionType);
        [DllImport("DS_WLanAPI.dll")]
        public static extern int DSAPIWLAN_GetCurrentAPInfo(ref DS_WLAN_STATUS pstStatus);
        [DllImport("DS_WLanAPI.dll")]
        public static extern int DSAPIWLAN_DeleteConfig(string szConfig);
        [DllImport("DS_WLanAPI.dll")]
        public static extern int DSAPIWLAN_AddConfig(string szConfigName, ref DS_WLAN_INFO pWlanInfo);
        [DllImport("DS_WLanAPI.dll")]
        public static extern int DSAPIWLAN_ActiveConfig(string szConfigName);
        [DllImport("DS_WLanAPI.dll")]
        public static extern int DSAPIWLAN_GetCurrentConfig(ref int dwNum, StringBuilder szConfigName);
        [DllImport("DS_WLanAPI.dll")]
        public static extern int DSAPIWLAN_ImportConfig();	//"\\Nand\\summit.sdc"
        [DllImport("DS_WLanAPI.dll")]
        public static extern int DSAPIWLAN_ExportConfig();	//"\\Nand\\summit.sdc"

        [DllImport("DS_WLanAPI.dll")]
        public static extern int DSAPIWLAN_RadioEnable();	
        [DllImport("DS_WLanAPI.dll")]
        public static extern int DSAPIWLAN_RadioDisable();	
        [DllImport("DS_WLanAPI.dll")]
        public static extern int DSAPIWLAN_RadioReconnect();	
        
        
        //[DllImport("DS_WLanAPI.dll")]
        //public static extern int DSAPIWLAN_GetAllConfigName(ref int dwNum, ref DS_WLAN_CONFIG_NAME[] pstConfigList);
        //public static extern int DSAPIWLAN_GetAllConfigName(ref DS_WLAN_CONFIG_NAME_LIST pstConfigList);


    }
}
