﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using DS_WLanAPINS;
using System.Threading;

namespace DS_WLanSampleCS
{
    public partial class Form1 : Form
    {
        Boolean m_bWlanPowerState;
        string m_strMsg;

        string m_strSSid;
        int m_nEncript;
        string m_strPwd;
        string m_strIP;
        string m_strSubM;
        string m_strGateW;
        string m_strDns1;
        string m_strDns2;
        string m_strWins1;
        string m_strWins2;

        public void ListMessage(string strMsg)
        {
            listBox1.Items.Add(strMsg);
        }

        public void WLanStateCheck()
        {
            DS_WLanAPI.DS_WLAN_STATUS st = new DS_WLanAPI.DS_WLAN_STATUS();
            DS_WLanAPI.DSAPIWLAN_GetCurrentAPInfo(ref st);

            string tmp = new string(st.CardState);
            m_strMsg = "Status : " + tmp;
            ListMessage(m_strMsg);


            if (tmp.CompareTo("NOT_INSERTED") != 0)
            {
                string ssid = new string(st.SSID);

                m_strMsg = "SSID : " + ssid;
                ListMessage(m_strMsg);
            }
            else if (st.Rssi == 0)
            {
            }

        }

        public Form1()
        {
            InitializeComponent();

            bool bRet = DS_WLanAPI.DSAPIWLAN_Init();



            DS_WLanAPI.DSAPIWLAN_GetPower(ref m_bWlanPowerState);
            if (m_bWlanPowerState)
            {
                button1.Text = "Power OFF";
                m_strMsg = "Current Wlan Power ON";
                ListMessage(m_strMsg);

                WLanStateCheck();
            }
            else
            {
                button1.Text = "Power ON";
                m_strMsg = "Current Wlan Power OFF";
                ListMessage(m_strMsg);

           }

           if (bRet)
           {
               m_strMsg = "DSAPIWLAN_Init OK";
               ListMessage(m_strMsg);
           }
           else
           {
               m_strMsg = "DSAPIWLAN_Init FAIL";
               ListMessage(m_strMsg);
           }

           comboBox1.SelectedIndex = 1;
            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (m_bWlanPowerState)
            {
                DS_WLanAPI.DSAPIWLAN_SetPower(false);
                m_bWlanPowerState = false;
                m_strMsg = "Wlan Power OFF";
                ListMessage(m_strMsg);

                button1.Text = "Power ON";
            }
            else
            {
                DS_WLanAPI.DSAPIWLAN_SetPower(true);

                Cursor.Current = Cursors.WaitCursor;
                for (int i = 0; i < 5; i++)
                {
                    Thread.Sleep(1000);
                    DS_WLanAPI.DS_WLAN_STATUS st = new DS_WLanAPI.DS_WLAN_STATUS();
                    DS_WLanAPI.DSAPIWLAN_GetCurrentAPInfo(ref st);

                    string tmp = new string(st.CardState);


                    if (tmp.CompareTo("NOT_INSERTED") != 0)
                    {
                        m_bWlanPowerState = true;
                        break;
                    }
                }

                Cursor.Current = Cursors.Default;
                if (m_bWlanPowerState)
                {
                    button1.Text = "Power OFF";
                    m_strMsg = "Wlan Power ON";
                    ListMessage(m_strMsg);

                    WLanStateCheck();
                }

            }
            
        }

        private void button3_Click(object sender, EventArgs e)
        {
            WLanStateCheck();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (textBox1.Text == "")
            {
                MessageBox.Show("SSID name is empty!");
                return;
            }

            if ((textBox2.Text == "") && (comboBox1.SelectedIndex>1))
            {
                MessageBox.Show("password is empty!");
                return;
            }

            string ssid = textBox1.Text;
            string pw = textBox2.Text;
            int enType = comboBox1.SelectedIndex;

            DS_WLanAPI.DS_WLAN_INFO WlanInfo = new DS_WLanAPI.DS_WLAN_INFO();


            m_strIP = textBox3.Text + "." + textBox4.Text + "." + textBox5.Text + "." + textBox6.Text;

            WlanInfo.SSID = ssid;
            WlanInfo.nEncrypt = enType;
            WlanInfo.EncryptKey = pw;
            WlanInfo.dwDHCPenable = 0;                  //static : 0, dhcp : 1
            WlanInfo.IPV4Address = m_strIP;
            WlanInfo.IPV4SubnetMask = m_strSubM;
            WlanInfo.IPV4Gateway = m_strGateW;
            WlanInfo.IPV4DNS1 = m_strDns1;
            WlanInfo.IPV4DNS2 = m_strDns2;
            WlanInfo.IPV4WINS1 = m_strWins1;
            WlanInfo.IPV4WINS2 = m_strWins2;


            int nResult;

            //int nResult = DS_WLanAPI.DSAPIWLAN_ConnectAP(ssid, pw, enType);
            nResult = DS_WLanAPI.DSAPIWLAN_AddConfig(ssid, ref WlanInfo);
            //nResult = DS_WLanAPI.DSAPIWLAN_ActiveConfig(ssid);

            if (nResult == 0)
            {
                Cursor.Current = Cursors.WaitCursor;
                for (int i = 0; i < 5; i++)
                {
                    Thread.Sleep(1000);
                    DS_WLanAPI.DS_WLAN_STATUS st = new DS_WLanAPI.DS_WLAN_STATUS();
                    DS_WLanAPI.DSAPIWLAN_GetCurrentAPInfo(ref st);

                    string tmp = new string(st.CardState);


                    if (tmp.CompareTo("ASSOCIATED") == 0)
                    {
                        break;
                    }
                }

                Cursor.Current = Cursors.Default;
                WLanStateCheck();
            }
            else 
            {
                m_strMsg = "ConnectAP fail code : " + nResult.ToString();
                ListMessage(m_strMsg);
            }


        }

        private void button6_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (textBox1.Text == "")
            {
                MessageBox.Show("SSID name is empty!");
                return;
            }

            string ssid = textBox1.Text;

            int nResult = DS_WLanAPI.DSAPIWLAN_DeleteConfig(ssid);

            if (nResult == 0)
            {
                ListMessage("DeleteConfig success.");
            }
            else
            {
                m_strMsg = "DeleteConfig fail code : " + nResult.ToString();
                ListMessage(m_strMsg);
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            int nNum=0;
            StringBuilder szConfig = new StringBuilder(33);

            int nResult = DS_WLanAPI.DSAPIWLAN_GetCurrentConfig(ref nNum, szConfig);
            if (nResult == 0)
            {
                m_strMsg = "GetCurrentConfig : " + szConfig + "[" + nNum.ToString() + "]";
                ListMessage(m_strMsg);
            }

        }

        private void button8_Click(object sender, EventArgs e)
        {
            int nResult = DS_WLanAPI.DSAPIWLAN_ExportConfig();
            if (nResult == 0)
            {
                m_strMsg = "Exported";
                ListMessage(m_strMsg);
            }
            else
            {
                m_strMsg = "Export fail code : " + nResult.ToString();
                ListMessage(m_strMsg);
            }
        }

        private void button9_Click(object sender, EventArgs e)
        {
            int nResult = DS_WLanAPI.DSAPIWLAN_ImportConfig();
            if (nResult == 0)
            {
                m_strMsg = "Imported";
                ListMessage(m_strMsg);
            }
            else
            {
                m_strMsg = "Import fail code : " + nResult.ToString();
                ListMessage(m_strMsg);
            }
        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            if (textBox1.Text == "")
            {
                MessageBox.Show("SSID name is empty!");
                return;
            }
            string ssid = textBox1.Text;

            int nResult;
            nResult = DS_WLanAPI.DSAPIWLAN_ActiveConfig(ssid);

            if (nResult == 0)
            {
                Cursor.Current = Cursors.WaitCursor;
                for (int i = 0; i < 5; i++)
                {
                    Thread.Sleep(1000);
                    DS_WLanAPI.DS_WLAN_STATUS st = new DS_WLanAPI.DS_WLAN_STATUS();
                    DS_WLanAPI.DSAPIWLAN_GetCurrentAPInfo(ref st);

                    string tmp = new string(st.CardState);


                    if (tmp.CompareTo("ASSOCIATED") == 0)
                    {
                        break;
                    }
                }

                Cursor.Current = Cursors.Default;
                WLanStateCheck();
            }
            else
            {
                m_strMsg = "ConnectAP fail code : " + nResult.ToString();
                ListMessage(m_strMsg);
            }

        }

        private void button11_Click(object sender, EventArgs e)
        {
            textBox3.Text = "192";
            textBox4.Text = "168";
            textBox5.Text = "1";
            textBox6.Text = "106";

            m_strSSid   = "DS5_WCE";
            m_nEncript  = 2;
            m_strPwd    = "qwertyui";
            m_strIP = textBox3.Text + "." + textBox4.Text + "." + textBox5.Text + "." + textBox6.Text;
            m_strSubM   = "255.255.255.0";
            m_strGateW  = "192.168.1.1";
            m_strDns1   = "";
            m_strDns2   = "";
            m_strWins1  = "";
            m_strWins2  = "";


            textBox1.Text = m_strSSid;
            comboBox1.SelectedIndex = m_nEncript;
            textBox2.Text = m_strPwd;
        }

        private void button12_Click(object sender, EventArgs e)
        {
            /*
            textBox3.Text = "192";
            textBox4.Text = "168";
            textBox5.Text = "0";
            textBox6.Text = "116";
            
            m_strSSid = "OS_TEST1";
            m_nEncript = 2;
            m_strPwd = "123123123";

            if ((textBox3.Text == "") || (textBox4.Text == "") || (textBox5.Text == "") || (textBox6.Text == ""))
                m_strIP = "";
            else
                m_strIP = textBox3.Text + "." + textBox4.Text + "." + textBox5.Text + "." + textBox6.Text;
            
            m_strSubM = "255.255.255.0";
            m_strGateW = "192.168.1.1";
            m_strDns1 = "";
            m_strDns2 = "";
            m_strWins1 = "";
            m_strWins2 = "";

            */

            textBox3.Text = "";
            textBox4.Text = "";
            textBox5.Text = "";
            textBox6.Text = "";

            m_strSSid = "OS_TEST1";
            m_nEncript = 2;
            m_strPwd = "123123123";

            if ((textBox3.Text == "") || (textBox4.Text == "") || (textBox5.Text == "") || (textBox6.Text == ""))
                m_strIP = "";
            else
                m_strIP = textBox3.Text + "." + textBox4.Text + "." + textBox5.Text + "." + textBox6.Text;
            
            m_strSubM = "";
            m_strGateW = "";
            m_strDns1 = "";
            m_strDns2 = "";
            m_strWins1 = "";
            m_strWins2 = "";

            textBox1.Text = m_strSSid;
            comboBox1.SelectedIndex = m_nEncript;
            textBox2.Text = m_strPwd;

        }

        private void button13_Click(object sender, EventArgs e)
        {
            textBox3.Text = "192";
            textBox4.Text = "168";
            textBox5.Text = "0";
            textBox6.Text = "7";

            m_strSSid = "DSICLAB";
            m_nEncript = 2;
            m_strPwd = "21075193";
            m_strIP = textBox3.Text + "." + textBox4.Text + "." + textBox5.Text + "." + textBox6.Text;
            m_strSubM = "255.255.255.0";
            m_strGateW = "192.168.0.1";
            m_strDns1 = "58.102.154.1";
            m_strDns2 = "164.124.101.2";
            m_strWins1 = "";
            m_strWins2 = "";


            textBox1.Text = m_strSSid;
            comboBox1.SelectedIndex = m_nEncript;
            textBox2.Text = m_strPwd;

        }

        private void button14_Click(object sender, EventArgs e)
        {
   /*         
            //DS_CommonAPI.DS_WLAN_CONFIG_NAME_LIST pstConfigList = new DS_CommonAPI.DS_WLAN_CONFIG_NAME_LIST();
            //pstConfigList.ConfigList = new DS_CommonAPI.DS_WLAN_CONFIG_NAME[20];

            int num=0;
            DS_WLanAPI.DS_WLAN_CONFIG_NAME[] configList = new DS_WLanAPI.DS_WLAN_CONFIG_NAME[20];
            for (int i = 0; i < 20; i++)
            {
                configList[i].ConfigName = "";
            }

            DS_WLanAPI.DSAPIWLAN_GetAllConfigName(ref num, ref configList);

            for (int i = 0; i < num; i++)
            {


                m_strMsg = "[" + i.ToString() + "]" + configList[i].ConfigName;
                ListMessage(m_strMsg);
            }
     */       
        }

        private void button15_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            int err = DS_WLanAPI.DSAPIWLAN_RadioReconnect();
            Cursor.Current = Cursors.Default;

            if (err == 0)
                m_strMsg = "[Reconnect] Success";
            else
                m_strMsg = "[Reconnect] Fail :" + err.ToString();

            ListMessage(m_strMsg);

            WLanStateCheck();
        }

        private void button16_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            int err = DS_WLanAPI.DSAPIWLAN_RadioEnable();
            Cursor.Current = Cursors.Default;
            if (err == 0)
                m_strMsg = "[RadioEnable] Success";
            else
                m_strMsg = "[RadioEnable] Fail :" + err.ToString();

            ListMessage(m_strMsg);

            WLanStateCheck();
        }

        private void button17_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            int err = DS_WLanAPI.DSAPIWLAN_RadioDisable();
            Cursor.Current = Cursors.Default;
            if (err == 0)
                m_strMsg = "[RadioDisable] Success";
            else
                m_strMsg = "[RadioDisable] Fail :" + err.ToString();

            ListMessage(m_strMsg);

            WLanStateCheck();
        }

    }
}